Index: frontends/php/include/defines.inc.php
===================================================================
--- frontends/php/include/defines.inc.php	(revisão 51477)
+++ frontends/php/include/defines.inc.php	(cópia de trabalho)
@@ -295,6 +295,7 @@
 define('MAP_LABEL_TYPE_STATUS',		3);
 define('MAP_LABEL_TYPE_NOTHING',	4);
 define('MAP_LABEL_TYPE_CUSTOM',		5);
+define('MAP_LABEL_TYPE_NAME_ONLY',		6);
 
 define('MAP_LABEL_LOC_DEFAULT', -1);
 define('MAP_LABEL_LOC_BOTTOM',	0);
Index: frontends/php/include/maps.inc.php
===================================================================
--- frontends/php/include/maps.inc.php	(revisão 51477)
+++ frontends/php/include/maps.inc.php	(cópia de trabalho)
@@ -46,6 +46,7 @@
 		MAP_LABEL_TYPE_IP => _('IP address'),
 		MAP_LABEL_TYPE_NAME => _('Element name'),
 		MAP_LABEL_TYPE_STATUS => _('Status only'),
+		MAP_LABEL_TYPE_NAME_ONLY => _('Element name only'),
 		MAP_LABEL_TYPE_NOTHING => _('Nothing'),
 		MAP_LABEL_TYPE_CUSTOM => _('Custom label')
 	);
@@ -2005,6 +2006,9 @@
 			$label[] = array('msg' => $elementInfo['name']);
 			$label = array_merge($label, $statusLines[$selementId]);
 		}
+		elseif ($selement['label_type'] == MAP_LABEL_TYPE_NAME_ONLY) {
+			$label = $labelLines[$selementId];
+		}
 		else {
 			$label = array_merge($labelLines[$selementId], $statusLines[$selementId]);
 		}
Index: frontends/php/sysmaps.php
===================================================================
--- frontends/php/sysmaps.php	(revisão 51477)
+++ frontends/php/sysmaps.php	(cópia de trabalho)
@@ -55,17 +55,17 @@
 	'show_unack' =>				array(T_ZBX_INT, O_OPT, null,	BETWEEN(0, 2),	null),
 	'highlight' =>				array(T_ZBX_INT, O_OPT, null,	BETWEEN(0, 1),	null),
 	'label_format' =>			array(T_ZBX_INT, O_OPT, null,	BETWEEN(0, 1),	null),
-	'label_type_host' =>		array(T_ZBX_INT, O_OPT, null,	BETWEEN(MAP_LABEL_TYPE_LABEL, MAP_LABEL_TYPE_CUSTOM), 'isset({add}) || isset({update})'),
-	'label_type_hostgroup' =>	array(T_ZBX_INT, O_OPT, null,	BETWEEN(MAP_LABEL_TYPE_LABEL, MAP_LABEL_TYPE_CUSTOM), 'isset({add}) || isset({update})'),
-	'label_type_trigger' =>		array(T_ZBX_INT, O_OPT, null,	BETWEEN(MAP_LABEL_TYPE_LABEL, MAP_LABEL_TYPE_CUSTOM), 'isset({add}) || isset({update})'),
-	'label_type_map' =>			array(T_ZBX_INT, O_OPT, null,	BETWEEN(MAP_LABEL_TYPE_LABEL, MAP_LABEL_TYPE_CUSTOM), 'isset({add}) || isset({update})'),
-	'label_type_image' =>		array(T_ZBX_INT, O_OPT, null,	BETWEEN(MAP_LABEL_TYPE_LABEL, MAP_LABEL_TYPE_CUSTOM), 'isset({add}) || isset({update})'),
+	'label_type_host' =>		array(T_ZBX_INT, O_OPT, null,	BETWEEN(MAP_LABEL_TYPE_LABEL, MAP_LABEL_TYPE_NAME_ONLY), 'isset({add}) || isset({update})'),
+	'label_type_hostgroup' =>	array(T_ZBX_INT, O_OPT, null,	BETWEEN(MAP_LABEL_TYPE_LABEL, MAP_LABEL_TYPE_NAME_ONLY), 'isset({add}) || isset({update})'),
+	'label_type_trigger' =>		array(T_ZBX_INT, O_OPT, null,	BETWEEN(MAP_LABEL_TYPE_LABEL, MAP_LABEL_TYPE_NAME_ONLY), 'isset({add}) || isset({update})'),
+	'label_type_map' =>			array(T_ZBX_INT, O_OPT, null,	BETWEEN(MAP_LABEL_TYPE_LABEL, MAP_LABEL_TYPE_NAME_ONLY), 'isset({add}) || isset({update})'),
+	'label_type_image' =>		array(T_ZBX_INT, O_OPT, null,	BETWEEN(MAP_LABEL_TYPE_LABEL, MAP_LABEL_TYPE_NAME_ONLY), 'isset({add}) || isset({update})'),
 	'label_string_host' =>		array(T_ZBX_STR, O_OPT, null,	null,			'isset({add}) || isset({update})'),
 	'label_string_hostgroup' =>	array(T_ZBX_STR, O_OPT, null,	null,			'isset({add}) || isset({update})'),
 	'label_string_trigger' =>	array(T_ZBX_STR, O_OPT, null,	null,			'isset({add}) || isset({update})'),
 	'label_string_map' =>		array(T_ZBX_STR, O_OPT, null,	null,			'isset({add}) || isset({update})'),
 	'label_string_image' =>		array(T_ZBX_STR, O_OPT, null,	null,			'isset({add}) || isset({update})'),
-	'label_type' =>				array(T_ZBX_INT, O_OPT, null,	BETWEEN(MAP_LABEL_TYPE_LABEL,MAP_LABEL_TYPE_CUSTOM), 'isset({add}) || isset({update})'),
+	'label_type' =>				array(T_ZBX_INT, O_OPT, null,	BETWEEN(MAP_LABEL_TYPE_LABEL, MAP_LABEL_TYPE_NAME_ONLY), 'isset({add}) || isset({update})'),
 	'label_location' =>			array(T_ZBX_INT, O_OPT, null,	BETWEEN(0, 3),	'isset({add}) || isset({update})'),
 	'urls' =>					array(T_ZBX_STR, O_OPT, null,	null,			null),
 	'severity_min' =>			array(T_ZBX_INT, O_OPT, null,	IN('0,1,2,3,4,5'), null),